// ColorSphere.h
//  5: "5)   "
	
//**********************************************************
// 
void SetLightColorSphere();				
void RenderSceneColorSphere();
void ChangeSizeColorSphere(int, int);
	
//    
GLfloat diffuseMaterial[] = {0.5, 0.5, 0.5, 1.0};
GLfloat mat_shininess[] = {25.0}; //   

void SetLightColorSphere()
{
	GLfloat mat_specular[] = {1.0, 1.0, 1.0, 1.0};//  
	GLfloat light_position[] = {1.0, 1.0, 1.0, 0.0};//  
	glClearColor(0.0, 0.0, 0.0, 1.0);
	glShadeModel(GL_SMOOTH);
	
	glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuseMaterial);//    
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess); 
	
	glLightfv(GL_LIGHT0, GL_POSITION, light_position);
	
 	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_DEPTH_TEST);
	
	//      
	glColorMaterial(GL_FRONT, GL_DIFFUSE);
	//    
	glEnable(GL_COLOR_MATERIAL);
}
	
//**********************************************************
void RenderSceneColorSphere()
{
	//      
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glPushMatrix();//    
	
	glRotatef(xRot, 1.0f, 0.0f, 0.0f);
	glRotatef(yRot, 0.0f, 1.0f, 0.0f);
	glRotatef(zRot, 0.0f, 0.0f, 1.0f);
	
	//  
	xRot += 1.0f;
	yRot += 1.0f;
	zRot += 1.0f;
	xRot = (GLfloat)((const int)xRot % 360);
	yRot = (GLfloat)((const int)yRot % 360);
	zRot = (GLfloat)((const int)zRot % 360);
	
	//  
	glutSolidSphere(1.0, 20, 16);
	
	glPopMatrix();//    
	
	//  
	glutSwapBuffers();
	
	//  
	glFlush();
}
	
//**********************************************************
void ChangeSizeColorSphere(int width, int height)
{	
	//   
	SetLightColorSphere();
	
	//    
	if(height == 0)
		height = 1;
	
	//      
	glViewport(0, 0, width, height);
	
	//      
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	//     
	GLfloat aspectRatio = (GLfloat)width / (GLfloat)height;//   
	
	if (width <= height) 
        glOrtho (-1.5, 1.5, -1.5 / aspectRatio, 1.5 / aspectRatio, -10.0, 10.0);
    else 
        glOrtho (-1.5 * aspectRatio, 1.5 * aspectRatio, -1.5, 1.5, -10, 10);
	
	//       
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}
