// CrystalAndSpot.h
//  9: "9)    "
	
//**********************************************************
// 
void CrystalAndSpot();
void SetLightCrystalAndSpot();
void RenderSceneCrystalAndSpot();
void ChangeSizeCrystalAndSpot(int, int);
	
//**********************************************************
//   
GLfloat	 light_positionCrystalAndSpot[] = { 0.0f, 0.0f, 75.0f, 1.0f };
GLfloat  specular[] = { 1.0f, 1.0f, 1.0f, 1.0f};
GLfloat  ambientLight[] = { 0.5f, 0.5f, 0.5f, 1.0f};
GLfloat  spotDir[] = { 0.0f, 0.0f, -1.0f };
	
//**********************************************************
//   
#define MODE_FLAT 1
#define MODE_SMOOTH  2
#define MODE_VERYLOW 3
#define MODE_MEDIUM  4
#define MODE_VERYHIGH 5
	
int iShade = MODE_FLAT;		//  
int iTess = MODE_VERYLOW;	// 
	
//**********************************************************
//  
void CrystalAndSpot()
{
	if(iShade == MODE_FLAT)
		glShadeModel(GL_FLAT);
	else // iShade == MODE_SMOOTH;
		glShadeModel(GL_SMOOTH);
	
	//     
	glPushMatrix();	
	
		//   
		glRotatef(yRot, 0.0f, 1.0f, 0.0f);
		glRotatef(xRot, 1.0f, 0.0f, 0.0f);
	
		//  
		glLightfv(GL_LIGHT0, GL_POSITION, light_positionCrystalAndSpot);
		glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, spotDir);
	
		//      
		glColor3ub(255, 0, 0);	
	
		//        
		glTranslatef(light_positionCrystalAndSpot[0], light_positionCrystalAndSpot[1], light_positionCrystalAndSpot[2]);
		glutSolidCone(6.0f, 10.0f, 15, 15);	//  
	
		//      
		glPushAttrib(GL_LIGHTING_BIT);
	
			//   ,      
			glDisable(GL_LIGHTING);
			glColor3ub(255, 255, 0);
			glutSolidSphere(5.0f, 15, 15);
	
		//      
		glPopAttrib();
	
	//     
	glPopMatrix();
	
	//      
	glColor3ub(0, 0, 255);
	
	if(iTess == MODE_VERYLOW)	//  
		glutSolidSphere(40.0f, 7, 7);
	else 
		if(iTess == MODE_MEDIUM)//  
			glutSolidSphere(40.0f, 15, 15);
		else //  iTess == MODE_VERYHIGH	//  
			glutSolidSphere(40.0f, 50, 50);
	
	//  
	glutSwapBuffers();
}
	
//**********************************************************
//      
void RenderSceneCrystalAndSpot()
{
	//      
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	//  
	CrystalAndSpot();
	
	//  
	glFlush();
}
	
//**********************************************************
//    
void SetLightCrystalAndSpot()
{
	//  
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambientLight);
	
	//   
	glLightfv(GL_LIGHT0, GL_DIFFUSE, ambientLight);
	glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
	glLightfv(GL_LIGHT0, GL_POSITION, light_positionCrystalAndSpot);
	//    
	glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 60.0f);
	
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	
	//    
	glEnable(GL_COLOR_MATERIAL);
	
	//        glColor()
	glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE);
	
	//  
	glMaterialfv(GL_FRONT, GL_SPECULAR, specular);	//  
	glMateriali(GL_FRONT, GL_SHININESS, 128);		//  
}
	
//**********************************************************
void ChangeSizeCrystalAndSpot(int width, int height)
{
	//    
	SetLightCrystalAndSpot();
	
    glEnable(GL_DEPTH_TEST);	//   
    glEnable(GL_CULL_FACE);		//    
    glFrontFace(GL_CCW);		//      
    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);//   
	
	//    
	if(height == 0)
		height = 1;
	
	//      
	glViewport(0, 0, width, height);
	
	//      
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	//      
	GLfloat aspectRatio = (GLfloat)width / (GLfloat)height;	//   
	gluPerspective(35.0f, aspectRatio, 1.0f, 500.0f);		//  
    
	//       
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	//       0z
	glTranslatef(0.0f, 0.0f, -250.0f);
}
